int findMaxNode(FILE *fk, bool doPrint)
{
//find shells in .k file
	char line[1000];
	
	if(NULL==fgets(line, sizeof(line), fk) ){
		printf("Failed to read first line of .k file\n");
		return -3;
	}
	while (NULL==strstr(line,"*ELEMENT_SHELL_THICKNESS")){
		if(NULL == fgets(line, sizeof(line), fk)){
			printf("Reached end of .k file before finding shells\n");
			return -4;
		}
	}
	// get next line of shell
	if(NULL == fgets(line, sizeof(line), fk)){
		printf("Reached end of .k file while reading first shell\n");
		return -5;
	}

	//find largest node number used
	int nodes[4];
	int maxNode=0;

	while (NULL==strstr(line,"*")){
		if(strstr(line,"$")){
			// get next line of shells
			if(NULL == fgets(line, sizeof(line), fk)){
				printf("Warning - Reached end of .k file before finding '*'\n");
			}
		}else{
			// save nodes
			if(4!=sscanf(line,"%*d%*d%d%d%d%d",&nodes[0],&nodes[1],&nodes[2],&nodes[3])){
				printf("Error reading shell connectivity\n");
				return -6;
			}
			// print debug message
			if(doPrint)
				printf("found nodes:");
			// find biggest node
			for(int j=0;j<4;j++){
				if(doPrint)
					printf(" %d",nodes[j]);
				if(nodes[j]>maxNode)
					maxNode=nodes[j];
			}
			if(doPrint)
				printf("\n");

			// skip thickness line of shell
			if(NULL == fgets(line, sizeof(line), fk)){
				printf("Expected line for thicknesses after node values in shell\n");
				return -7;
			}
			// get next line of shells
			if(NULL == fgets(line, sizeof(line), fk)){
				printf("Warning - Reached end of .k file before finding '*'\n");
			}
		}
	}

	if(doPrint)
		printf("\nMax node found in shells has value: %d\n",maxNode);

	return maxNode;
}
