// findSurfNodes.cpp : Defines the entry point for the console application.

// Written by Janna Balling
// 9/23/04

#include "stdafx.h"

#include <iostream>
using namespace std;
#include <stdio.h>

#include "findMaxNode.cpp"

// USAGE  prints usage message to screen
void usage()
{
   	printf("Finds the surface nodes (largest node number) used in the given shells of a lsdyna .k file\n");
	printf("Usage: findSurfNodes [lsdyna shell file (.k)] [OPTIONS]\n");
	printf("\nOPTIONS:\n");
	printf("  -print                     = print debugging progress messages to screen\n");
	exit(-1);
}

// FAIL_OR_OPEN  opens file for reading(rt) or writing(wb)
FILE * fail_or_open(const char *path, const char *opt)
{
   FILE *f = fopen(path, opt);
   if(!f) {
     printf("Failure opening file %s\n", path);
     exit(-13);
   }
   return f;
}

// FILECLOSER  make sure open files get closed
struct FileCloser {   
   FileCloser(FILE *f) : m_file(f) {}
   ~FileCloser() { if(m_file) fclose(m_file); }
   FILE *m_file;
};


int main(int argc, char* argv[])
{
	printf("\n");
	if(NULL==argv[1]){
		usage();
		return -1;
	}

	FILE *fk;
	bool doPrint=false;
	
	fk = fail_or_open(argv[1], "rt");
	FileCloser fc1(fk);

	//get and save options from the user
	for(int i=2;i<argc;i++){
		if(0==strcmp(argv[i],"-print")){
			doPrint=true;
			printf("debugg printing on\n");
		}
	}
	printf("Scanning shells in file: %s\n\n",argv[1]);

	//findMaxNode using function
	int numsurfNodes = findMaxNode(fk,doPrint);

	printf("\nNumber of surface nodes found : %d\n",numsurfNodes);
	return 0;
}





