// mergeFiles.cpp : Defines the entry point for the console application.

// Written by Janna Balling
// 6/04/04

#include "stdafx.h"

#pragma once
#include <iostream>
using namespace std;
#include <stdio.h>
#include <math.h>
#include <string.h>

// USAGE  prints usage message to screen
void usage()
{
	printf("prints the contents of two files into one\n");
	printf("Usage: mergeFiles [first file] [second file] [OPTIONS]\n");
	printf("\nOPTIONS:\n");
	printf("  -o <outfile> = output file name; default 'out'\n");
	exit(-1);
}

// FAIL_OR_OPEN  opens file for reading(rt) or writing(wb)
FILE * fail_or_open(const char *path, const char *opt)
{
   FILE *f = fopen(path, opt);
   if(!f) {
     printf("Failure opening file %s\n", path);
     exit(-13);
   }
   return f;
}

// FILECLOSER  make sure open files get closed
struct FileCloser {   
   FileCloser(FILE *f) : m_file(f) {}
   ~FileCloser() { if(m_file) fclose(m_file); }
   FILE *m_file;
};

int main(int argc, char* argv[])
{
	printf("\n");
	if(argc<2) {
		usage();
		return -1;
	}

	FILE *fin1, *fin2, *fout;

	fin1 = fail_or_open(argv[1], "rt");
	fin2 = fail_or_open(argv[2], "rt");
	FileCloser fc1(fin1), fc2(fin2);

	//get and save options from the user
	bool noOutFile=true;
	for(int i=3;i<argc;i++){
		if(0==strcmp(argv[i],"-o")){
            fout	= fail_or_open(argv[i+1], "wt");
			printf("writing to file : %s\n",argv[i+1]);
			noOutFile=false;
			i++;
		}
	}
	if(noOutFile){
		fout	= fail_or_open("out", "wt");
		printf("writing to file : out\n");
	}
	FileCloser fc3(fout);

	printf("merging from file: %s\n",argv[1]);
	printf("   then from file: %s\n\n",argv[2]);

	//print first file
	char line[1000];

	while(NULL!=fgets(line,sizeof(line),fin1)){
		fprintf(fout,"%s",line);
	}
	//print second file
	while(NULL!=fgets(line,sizeof(line),fin2)){
		fprintf(fout,"%s",line);
	}

	printf("Finished merging files.\n");
	return 0;
}

