// ImageSet.cpp: implementation of the CImageSet class.

#include "stdafx.h"

#pragma once
#include "ImageSet.h"

CImageSet::CImageSet()
{
	m_pData = NULL;
	m_cx = m_cy = m_cz = m_count = 0;
}

CImageSet::~CImageSet()
{
	CleanUp();
}

bool CImageSet::ReadImageSet(const char* szFileName, int cx, int cy, int cz, int n)
{
	FILE* fp = fopen(szFileName, "rb");
	if (fp == NULL)
		return false;

	//print to ascii file for checking
	FILE* ap = fopen("ascii2.vtk","wt");
	if (ap == NULL)
		return false;

	CleanUp();

	m_pData = new WORD[cx*cy*cz*n];

	if (m_pData == NULL){
		fclose(fp);
		return false;
	}

	fread(m_pData, sizeof(WORD), cx*cy*cz*n, fp);	

	for(int i=0;i<64;i++){
		for(int line=0;line<16;line++){
			WORD* temp=m_pData + i;
			int temp2=*temp;
			fprintf(ap,"%6d",temp2);
			i++;
		}
		fprintf(ap,"\n");
	}
	fprintf(ap,"\n");fprintf(ap,"\n");
	for(int i=(cx*cy*cz*n)-64;i<cx*cy*cz*n;i++){
		for(int line=0;line<16;line++){
			WORD* temp=m_pData + i;
			int temp2=*temp;
			fprintf(ap,"%6d",temp2);
			i++;
		}
		fprintf(ap,"\n");
	}


	fclose(fp);
	fclose(ap);
	m_cx = cx;
	m_cy = cy;
	m_cz = cz;
	m_count = n;

	return true;
}
