// ImageSet.h: interface for the CImageSet class.

#pragma once
#include <iostream>
using namespace std;

typedef unsigned short WORD;

class CImageSet  
{
friend class CMesh;
public:
	CImageSet();
	virtual ~CImageSet();

	bool ReadImageSet(const char* szFileName, int cx, int cy, int cz, int n);

	WORD* Pixel(int i, int j, int k)
	{
		return m_pData + k*(m_cx*m_cy*m_cz) + j*m_cx + i;
	}

private:
	void CleanUp()
	{
		delete [] m_pData;
		m_cx = m_cy = m_cz = m_count = 0;
	}

	WORD	*m_pData;   // data from raw file
	int		m_cx;		// width
	int		m_cy;		// height
	int		m_cz;		// width of 1 image
	int		m_count;	// number of images
};
