// nodeReader class

// Written by Janna Balling
// 6/04/04

// Returns the next integer in file as the next node.  Also, expands 
// integers when necessary.  Ex: 4:6 expands to 4 5 6. getNext() 
// returns 0 when reaching an end of the file.  Anything other than
// integers are skipped.

//Usage Example:
//
// #include "path/nodeReader/nodeReader.cpp"
//
// FILE *fileName=fopen("file.nodes","rt");
// nodeReader name;
// name.setFile(fileName);
// int nextNode=name.getNext();

class nodeReader
{
public:
	int getNext(){
		char word[20],garbage;
		if(node==stopnode){
			if(EOF==fscanf(fnodes,"%s",word)){
				node=0;
				return 0;
			}
			while(1!=sscanf(word," %d",&node)){
				if(EOF==fscanf(fnodes,"%s",word)){
					node=0;
					return 0;
				}
			}
			stopnode=node;
			sscanf(word,"%d%c%d",&node,&garbage,&stopnode);
			nodecount++;
			return node;
		}
		else{
			node++;
			nodecount++;
			return node;
		}
	}

	int setFile(FILE *fin){
		fnodes=fin;
		nodecount=0;
		stopnode=node=0;
		char line[1000];
		int temp;
		long fileposition=ftell(fnodes);

		if(NULL==fgets(line, sizeof(line), fnodes) ){
			printf("Failed to read first line of fnodes file\n");
			return -1;
		}
		while (1!=sscanf(line,"%d",&temp)){
			fileposition=ftell(fnodes);
			if(NULL == fgets(line, sizeof(line), fnodes)){
				printf("Reached end of fnodes file before finding a node\n");
				return -2;
			}

		}
		fseek(fnodes,fileposition,SEEK_SET);
		return 0;
	}

private:
	FILE *fnodes;
	int nodecount,node,stopnode;
};

